from tkinter import *
import sqlite3
from tkinter.ttk import Style
import serial


class Data(Frame):

    def __init__(self, parent):
        Frame.__init__(self, parent)

        self.style = Style()
        self.status = ''
        self.parent = parent
        self.initPage()

    def initPage(self):
        self.parent.title("")
        self.style.theme_use("default")
        self.pack(fill=BOTH, expand=True)

        Title = Frame(self)
        Title.pack(fill=X)

        title = Label(Title, text="Insert datas")
        title.pack(fill=X, padx=5, pady=8, expand=True)
        FName = Frame(self)
        FName.pack(fill=X)

        s_fname = Label(FName, text="First Name: ", width=8)
        s_fname.pack(side=LEFT, fill=X, padx=5, pady=8, expand=True)

        self.fname = Entry(FName)
        self.fname.pack(fill=X, padx=2, expand=True)

        LName = Frame(self)
        LName.pack(fill=X)

        s_lname = Label(LName, text="Last Name: ", width=8)
        s_lname.pack(side=LEFT, fill=X, padx=5, pady=8, expand=True)
        self.lname = Entry(LName)
        self.lname.pack(fill=X, padx=2, expand=True)

        AGE = Frame(self)
        AGE.pack(fill=X)
        s_age = Label(AGE, text="Age: ", width=8)
        s_age.pack(side=LEFT, fill=X, padx=5, pady=8, expand=True)
        self.age1 = Entry(AGE)
        self.age1.pack(fill=X, padx=5, expand=True)

        # SAVE
        saveFrame = Frame(self, relief=RAISED, borderwidth=1)
        saveFrame.pack(fill=BOTH, expand=True)

        saveButton = Button(self, text="Save", command=self.SaveDetails)
        saveButton.pack(side=RIGHT, padx=5, pady=5)

    def SaveDetails(self):
        # Create Database
        conn = sqlite3.connect("date.db")
        c = conn.cursor()

        # Create Table - workersNames
        c.execute('''create table if not exists Data_Base(
            fname text, lname text, age integer, bpm integer)''')
        conn.commit()
        ser = serial.Serial("COM4", 9600, timeout=1)
        nr = 0
        suma = 0
        bpm = []
        while (True):
            input_data = []
            if ser.isOpen():
                input_data = ser.readline().strip().decode("utf-8")
                if input_data != '' and input_data != 'gata':
                    nr += 1
                    bpm.append(input_data)
            if input_data == 'gata':
                ser.close()
                break
        for i in bpm:
            suma += int(i)
        BPM = suma / nr
        print("BPM: ", BPM)
        # Add data to table
        c.execute("insert into Data_Base(fname, lname, age, bpm) values (?, ?, ?, ?)",
                  (self.fname.get(), self.lname.get(),
                   self.age1.get(), int(BPM)))
        conn.commit()

        c.close()
        conn.close()
        print('Data saved!')


def main():
    root = Tk()
    root.geometry("300x300+300+300")
    app = Data(root)
    root.mainloop()


if __name__ == '__main__':
    main()
